<?php
namespace Bushelpowered\Api\Aggregator\Crm\V1\Request;
        
class UpdateCustomerRequest 
{
    /** @var string $id The primary unique identifier.*/
    public string $id;
    /** @var string $name The name of the customer, editable*/
    public string $name;
    /** @var \Bushelpowered\Api\Aggregator\Crm\V1\Request\ContactInformationRequest[] $phones An array of phone numbers for the customer to create (id is null) or update. If an existing phone is not in the list it will be deleted.*/
    public array $phones;
    /** @var \Bushelpowered\Api\Aggregator\Crm\V1\Request\ContactInformationRequest[] $emails An array of emails for the customer to create (id is null) or update. If an existing email is not in the list it will be deleted.*/
    public array $emails;
    /** @var \Bushelpowered\Api\Aggregator\Crm\V1\Request\AddressRequest[] $addresses An array of addresses for the customer to create (id is null) or update. If an existing address is not in the list it will be deleted.*/
    public array $addresses;

    /**
     * @param  string  $id The primary unique identifier.
     * @param  string  $name The name of the customer, editable
     * @param  \Bushelpowered\Api\Aggregator\Crm\V1\Request\ContactInformationRequest[]  $phones An array of phone numbers for the customer to create (id is null) or update. If an existing phone is not in the list it will be deleted.
     * @param  \Bushelpowered\Api\Aggregator\Crm\V1\Request\ContactInformationRequest[]  $emails An array of emails for the customer to create (id is null) or update. If an existing email is not in the list it will be deleted.
     * @param  \Bushelpowered\Api\Aggregator\Crm\V1\Request\AddressRequest[]  $addresses An array of addresses for the customer to create (id is null) or update. If an existing address is not in the list it will be deleted.
     */
    public function __construct(string $id, string $name, array $phones, array $emails, array $addresses)
    {
        $this->id = $id;
        $this->name = $name;
        $this->phones = $phones;
        $this->emails = $emails;
        $this->addresses = $addresses;
    }
    

}