<?php
namespace Bushelpowered\Api\Crm\V1\Request;
        
class UpdateDemographicRequest 
{
    /** @var string $id Id of the demographic to update*/
    public string $id;
    /** @var null|float $onFarmStorageCapacity Total on-farm storage capacity*/
    public ?float $onFarmStorageCapacity = null;
    /** @var null|string $onFarmStorageCapacityUoM Total on-farm's storage capacity's unit of measure, default of bu*/
    public ?string $onFarmStorageCapacityUoM = null;
    /** @var null|string $additionalDestinationLocations Additional destinations or locations for the demographic*/
    public ?string $additionalDestinationLocations = null;
    /** @var null|string $comments Any comments about the demographic*/
    public ?string $comments = null;
    /** @var \Bushelpowered\Api\Crm\V1\Request\UpdateCommodityRequest[] $commodities An array of commodities for the demographic to create (id is null) or update. If an existing commodity is not in the list it will be deleted.*/
    public array $commodities;

    /**
     * @param  string  $id Id of the demographic to update
     * @param  null|float  $onFarmStorageCapacity Total on-farm storage capacity
     * @param  null|string  $onFarmStorageCapacityUoM Total on-farm's storage capacity's unit of measure, default of bu
     * @param  null|string  $additionalDestinationLocations Additional destinations or locations for the demographic
     * @param  null|string  $comments Any comments about the demographic
     * @param  \Bushelpowered\Api\Crm\V1\Request\UpdateCommodityRequest[]  $commodities An array of commodities for the demographic to create (id is null) or update. If an existing commodity is not in the list it will be deleted.
     */
    public function __construct(string $id, ?float $onFarmStorageCapacity, ?string $onFarmStorageCapacityUoM, ?string $additionalDestinationLocations, ?string $comments, array $commodities)
    {
        $this->id = $id;
        $this->onFarmStorageCapacity = $onFarmStorageCapacity;
        $this->onFarmStorageCapacityUoM = $onFarmStorageCapacityUoM;
        $this->additionalDestinationLocations = $additionalDestinationLocations;
        $this->comments = $comments;
        $this->commodities = $commodities;
    }
    

}