<?php
namespace Bushelpowered\Api\Fulfillment\Ticket\V1\Common;
        
class Filters 
{
    /** @var string[]|null $commodityCodes The list of commodity codes*/
    public ?array $commodityCodes = null;
    /** @var null|string $startDate The start date of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $startDate = null;
    /** @var null|string $endDate The end date of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $endDate = null;
    /** @var string[]|null $locationIds The list of location ids*/
    public ?array $locationIds = null;

    /**
     * @param  string[]|null  $commodityCodes The list of commodity codes
     * @param  null|string  $startDate The start date of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $endDate The end date of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string[]|null  $locationIds The list of location ids
     */
    public function __construct(?array $commodityCodes, ?string $startDate, ?string $endDate, ?array $locationIds)
    {
        $this->commodityCodes = $commodityCodes;
        $this->startDate = $startDate;
        $this->endDate = $endDate;
        $this->locationIds = $locationIds;
    }
    

}