<?php
namespace Bushelpowered\Api\Iam\Access\Common\V1;
        
class Role implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasUpdatedAtTimestamp
{
    /** @var string $id */
    public string $id;
    /** @var string $name The name of the role*/
    public string $name;
    /** @var bool $isTenantDefined Indicates the role is defined by the tenant*/
    public bool $isTenantDefined;
    /** @var null|string $tenantId The id of the tenant that defined this role. When null the role is created and managed by the Bushel Platform.*/
    public ?string $tenantId = null;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  string  $id 
     * @param  string  $name The name of the role
     * @param  bool  $isTenantDefined Indicates the role is defined by the tenant
     * @param  null|string  $tenantId The id of the tenant that defined this role. When null the role is created and managed by the Bushel Platform.
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $name, bool $isTenantDefined, ?string $tenantId, string $createdAt, string $updatedAt)
    {
        $this->id = $id;
        $this->name = $name;
        $this->isTenantDefined = $isTenantDefined;
        $this->tenantId = $tenantId;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
}