<?php
namespace Bushelpowered\Api\Iam\Access\Evaluate\V1\Request;
        
class CheckResourceRequest implements \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\HasConsistency, \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\HasPermissions, \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\HasResource
{
    /** @var null|\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\Consistency $consistency */
    public ?\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\Consistency $consistency = null;
    /** @var string[] $permissions The permissions to check or lookup. Use the GetAllPermissions operation to see available options.*/
    public array $permissions;
    /** @var \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ResourceRef $resource */
    public \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ResourceRef $resource;

    /**
     * @param  null|\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\Consistency  $consistency 
     * @param  string[]  $permissions The permissions to check or lookup. Use the GetAllPermissions operation to see available options.
     * @param  \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ResourceRef  $resource 
     */
    public function __construct(?\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\Consistency $consistency, array $permissions, \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ResourceRef $resource)
    {
        $this->consistency = $consistency;
        $this->permissions = $permissions;
        $this->resource = $resource;
    }
    
    /**
     * @return null|\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\Consistency 
     */
    public function getConsistency(): ?\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\Consistency
    {
        return $this->consistency;
    }
    /**
     * @return string[] The permissions to check or lookup. Use the GetAllPermissions operation to see available options.
     */
    public function getPermissions(): array
    {
        return $this->permissions;
    }
    /**
     * @return \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ResourceRef 
     */
    public function getResource(): \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ResourceRef
    {
        return $this->resource;
    }
}