<?php
namespace Bushelpowered\Api\Iam\Access\Manage\V1;

use \Bushelpowered\Api\Common\Request\EmptyRequest;
use \Bushelpowered\Api\Iam\Access\Manage\V1\Response\GetAllPermissionsResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetAllPermissions 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(EmptyRequest $request, $headers): GetAllPermissionsResponse | BadRequest | UnknownError
    {
         return $this->client->call('api/iam/access/manage/v1/GetAllPermissions', $request, $this->getWrapper(), $headers);
    }
    
    public function request(EmptyRequest $request, GetAllPermissionsMetadata $hasHeaders): GetAllPermissionsResponse | BadRequest | UnknownError
    {
         return $this->client->call('api/iam/access/manage/v1/GetAllPermissions', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var GetAllPermissionsResponse | BadRequest | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.iam.access.manage.v1#GetAllPermissionsSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Iam\Access\Manage\V1\Response\GetAllPermissionsResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}