<?php
namespace Bushelpowered\Api\Platform\Branding\V1;

use \Bushelpowered\Api\Platform\Branding\V1\Request\GetBundleIdsRequest;
use \Bushelpowered\Api\Platform\Branding\V1\Response\GetBundleIdsResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetBundleIds 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(GetBundleIdsRequest $request, $headers): GetBundleIdsResponse | BadRequest | NotAuthenticated | UnknownError
    {
         return $this->client->call('api/platform/branding/v1/GetBundleIds', $request, $this->getWrapper(), $headers);
    }
    
    public function request(GetBundleIdsRequest $request, GetBundleIdsMetadata $hasHeaders): GetBundleIdsResponse | BadRequest | NotAuthenticated | UnknownError
    {
         return $this->client->call('api/platform/branding/v1/GetBundleIds', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var GetBundleIdsResponse | BadRequest | NotAuthenticated | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.platform.branding.v1#GetBundleIdsSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Platform\Branding\V1\Response\GetBundleIdsResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}