<?php
namespace Bushelpowered\Api\Platform\Location\V1\Event;
        
class LocationEvent implements \Bushelpowered\Api\Common\Event\Event, \Bushelpowered\Api\Common\Event\StandardEvent, \Bushelpowered\Api\Common\Event\StandardEventWithPrevious
{
    /** @var \Bushelpowered\Api\Platform\Location\V1\Model\LocationStandard $data */
    public \Bushelpowered\Api\Platform\Location\V1\Model\LocationStandard $data;
    /** @var null|\Bushelpowered\Api\Platform\Location\V1\Model\LocationStandard $previousData */
    public ?\Bushelpowered\Api\Platform\Location\V1\Model\LocationStandard $previousData = null;
    /** @var string $idempotencyKey A key to uniquely identify this event.*/
    public string $idempotencyKey;
    /** @var string $eventCreationTime The time the event was created. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $eventCreationTime;
    /** @var null|string $tenantId The tenant that this event belongs to/was emitted for. Null if an event is not for a specific tenant.*/
    public ?string $tenantId = null;

    /**
     * @param  \Bushelpowered\Api\Platform\Location\V1\Model\LocationStandard  $data 
     * @param  null|\Bushelpowered\Api\Platform\Location\V1\Model\LocationStandard  $previousData 
     * @param  string  $idempotencyKey A key to uniquely identify this event.
     * @param  string  $eventCreationTime The time the event was created. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $tenantId The tenant that this event belongs to/was emitted for. Null if an event is not for a specific tenant.
     */
    public function __construct(\Bushelpowered\Api\Platform\Location\V1\Model\LocationStandard $data, ?\Bushelpowered\Api\Platform\Location\V1\Model\LocationStandard $previousData, string $idempotencyKey, string $eventCreationTime, ?string $tenantId)
    {
        $this->data = $data;
        $this->previousData = $previousData;
        $this->idempotencyKey = $idempotencyKey;
        $this->eventCreationTime = $eventCreationTime;
        $this->tenantId = $tenantId;
    }
    
    /**
     * @return \Bushelpowered\Api\Platform\Location\V1\Model\LocationStandard 
     */
    public function getData(): \Bushelpowered\Api\Platform\Location\V1\Model\LocationStandard
    {
        return $this->data;
    }
    /**
     * @return null|\Bushelpowered\Api\Platform\Location\V1\Model\LocationStandard 
     */
    public function getPreviousData(): ?\Bushelpowered\Api\Platform\Location\V1\Model\LocationStandard
    {
        return $this->previousData;
    }
    /**
     * @return string A key to uniquely identify this event.
     */
    public function getIdempotencyKey(): string
    {
        return $this->idempotencyKey;
    }
    /**
     * @return string The time the event was created. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getEventCreationTime(): string
    {
        return $this->eventCreationTime;
    }
    /**
     * @return null|string The tenant that this event belongs to/was emitted for. Null if an event is not for a specific tenant.
     */
    public function getTenantId(): ?string
    {
        return $this->tenantId;
    }
}