<?php
namespace Bushelpowered\Api\Statement\V1\Request;
        
class GetAllStatementsRequest implements \Bushelpowered\Api\Common\RequestsPagination
{
    /** @var string[]|null $ids */
    public ?array $ids = null;
    /** @var string[]|null $tenantIds */
    public ?array $tenantIds = null;
    /** @var string[]|null $integrationIds */
    public ?array $integrationIds = null;
    /** @var string[]|null $accountIds */
    public ?array $accountIds = null;
    /** @var null|string $sourceDueDateStart  of yyyy-MM-dd format, IE: 2023-10-04*/
    public ?string $sourceDueDateStart = null;
    /** @var null|string $sourceDueDateEnd  of yyyy-MM-dd format, IE: 2023-10-04*/
    public ?string $sourceDueDateEnd = null;
    /** @var null|string $sourceIssueDateStart  of yyyy-MM-dd format, IE: 2023-10-04*/
    public ?string $sourceIssueDateStart = null;
    /** @var null|string $sourceIssueDateEnd  of yyyy-MM-dd format, IE: 2023-10-04*/
    public ?string $sourceIssueDateEnd = null;
    /** @var null|\Bushelpowered\Api\Statement\V1\Request\StatementPagination $pagination */
    public ?\Bushelpowered\Api\Statement\V1\Request\StatementPagination $pagination = null;

    /**
     * @param  string[]|null  $ids 
     * @param  string[]|null  $tenantIds 
     * @param  string[]|null  $integrationIds 
     * @param  string[]|null  $accountIds 
     * @param  null|string  $sourceDueDateStart  of yyyy-MM-dd format, IE: 2023-10-04
     * @param  null|string  $sourceDueDateEnd  of yyyy-MM-dd format, IE: 2023-10-04
     * @param  null|string  $sourceIssueDateStart  of yyyy-MM-dd format, IE: 2023-10-04
     * @param  null|string  $sourceIssueDateEnd  of yyyy-MM-dd format, IE: 2023-10-04
     * @param  null|\Bushelpowered\Api\Statement\V1\Request\StatementPagination  $pagination 
     */
    public function __construct(?array $ids, ?array $tenantIds, ?array $integrationIds, ?array $accountIds, ?string $sourceDueDateStart, ?string $sourceDueDateEnd, ?string $sourceIssueDateStart, ?string $sourceIssueDateEnd, ?\Bushelpowered\Api\Statement\V1\Request\StatementPagination $pagination)
    {
        $this->ids = $ids;
        $this->tenantIds = $tenantIds;
        $this->integrationIds = $integrationIds;
        $this->accountIds = $accountIds;
        $this->sourceDueDateStart = $sourceDueDateStart;
        $this->sourceDueDateEnd = $sourceDueDateEnd;
        $this->sourceIssueDateStart = $sourceIssueDateStart;
        $this->sourceIssueDateEnd = $sourceIssueDateEnd;
        $this->pagination = $pagination;
    }
    
    /**
     * @return null|\Bushelpowered\Api\Statement\V1\Request\StatementPagination 
     */
    public function getPagination(): ?\Bushelpowered\Api\Statement\V1\Request\StatementPagination
    {
        return $this->pagination;
    }
}