<?php
namespace Bushelpowered\Api\Trade\Futures\V1\Model;
        
class TradeLocation 
{
    /** @var string $id The location's unique identifier in the futures database.*/
    public string $id;
    /** @var string $companyId The company's unique identifier in the futures database.*/
    public string $companyId;
    /** @var int $centreId The Elevator Id in Centre that corresponds to the location.*/
    public int $centreId;
    /** @var int $cqgCategoryId The Id in CQG that corresponds to the location.*/
    public int $cqgCategoryId;
    /** @var string $displayName The name of the location.*/
    public string $displayName;
    /** @var int $sortOrder The order in which the location should be displayed (ascending).*/
    public int $sortOrder;
    /** @var null|string $salesSeriesId The Sales Series Id from CQG-Accounts that this Location is under in CQG*/
    public ?string $salesSeriesId = null;
    /** @var null|string $remoteId The Company's remote id (aka erp id or source id) for the location.*/
    public ?string $remoteId = null;
    /** @var null|string $bushelLocationId The Tenant Location Id that corresponds to the location.*/
    public ?string $bushelLocationId = null;

    /**
     * @param  string  $id The location's unique identifier in the futures database.
     * @param  string  $companyId The company's unique identifier in the futures database.
     * @param  int  $centreId The Elevator Id in Centre that corresponds to the location.
     * @param  int  $cqgCategoryId The Id in CQG that corresponds to the location.
     * @param  string  $displayName The name of the location.
     * @param  int  $sortOrder The order in which the location should be displayed (ascending).
     * @param  null|string  $salesSeriesId The Sales Series Id from CQG-Accounts that this Location is under in CQG
     * @param  null|string  $remoteId The Company's remote id (aka erp id or source id) for the location.
     * @param  null|string  $bushelLocationId The Tenant Location Id that corresponds to the location.
     */
    public function __construct(string $id, string $companyId, int $centreId, int $cqgCategoryId, string $displayName, int $sortOrder, ?string $salesSeriesId, ?string $remoteId, ?string $bushelLocationId)
    {
        $this->id = $id;
        $this->companyId = $companyId;
        $this->centreId = $centreId;
        $this->cqgCategoryId = $cqgCategoryId;
        $this->displayName = $displayName;
        $this->sortOrder = $sortOrder;
        $this->salesSeriesId = $salesSeriesId;
        $this->remoteId = $remoteId;
        $this->bushelLocationId = $bushelLocationId;
    }
    

}