<?php
namespace Bushelpowered\Api\Trade\Futures\V1\Request;
        
class BidsRequestByGroup 
{
    /** @var string $groupId The group id to get bids for.*/
    public string $groupId;
    /** @var null|int $bidLimit The number of bids return, all of them if null.*/
    public ?int $bidLimit = null;
    /** @var bool $comprehensive Whether or not to return all bid types. Required to be set to true if group is basis or hedge type.*/
    public bool $comprehensive;

    /**
     * @param  string  $groupId The group id to get bids for.
     * @param  null|int  $bidLimit The number of bids return, all of them if null.
     * @param  bool  $comprehensive Whether or not to return all bid types. Required to be set to true if group is basis or hedge type.
     */
    public function __construct(string $groupId, ?int $bidLimit, bool $comprehensive)
    {
        $this->groupId = $groupId;
        $this->bidLimit = $bidLimit;
        $this->comprehensive = $comprehensive;
    }
    

}